/*
 * WIVER Zealtume IIa (Mdclock)
 * 1999-5-26
 * 2000-7-18
 */

static char     rcsid[] = "$Id: mdclock.c,v 1.1 2000/07/18 08:41:36 root Exp $";

#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <string.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Command.h>
#include <X11/Xlib.h>
#include <X11/Shell.h>
#include <X11/Xutil.h>
#include <X11/Xaw/AsciiText.h>
/* #include <Xaw/XawI18n.h> */
#include <X11/Xlocale.h>
#include <X11/extensions/shape.h>
#include <X11/cursorfont.h>
#include <locale.h>
#include <X11/xpm.h>
#include <X11/Intrinsic.h>
#include <time.h>
#include <math.h>
#include "cg/mdclock2.xpm"
#include "cg/mdclock3.xpm"
#include "cg/mdclock.msk"
#include "cg/mdclockB.msk"
#include "cg/panel.msk"
#include "cg/mdclockicon.icon"

#include "cg/D0.xpm"
#include "cg/D1.xpm"
#include "cg/D2.xpm"
#include "cg/D3.xpm"
#include "cg/D4.xpm"
#include "cg/D5.xpm"
#include "cg/D6.xpm"
#include "cg/D7.xpm"
#include "cg/D8.xpm"
#include "cg/D9.xpm"
#include "cg/Dc.xpm"

#include "cg/FDR0.XPM"
#include "cg/FDR1.XPM"
#include "cg/FDR2.XPM"
#include "cg/FDR3.XPM"
#include "cg/FDR4.XPM"
#include "cg/FDR5.XPM"
#include "cg/FDR6.XPM"
#include "cg/FDR7.XPM"
#include "cg/FDR8.XPM"
#include "cg/FDR9.XPM"
#include "cg/FDRC.XPM"

#define MAXWW            104
#define MAXWH            104
#define MINWW            104
#define MINWH            104
#define xpmEnable          1
#define mskEnable          2
#define xpmmskEnable       3
#define RAD         M_PI/180
#define INTERVAL_TIME   1000
#define LIGHTOFF_TIME   2000
#define PIXPOSSTEP        15
#define poplabelWIDTH     80
#define poplabelHEIGHT    20

#define funcbtn_width     10
#define funcbtn_height    10
#define POPED              1

enum panelmodeval {NORMAL, ANALOG, DIGITAL, BACKON, BACKOFF};

XtAppContext    app_con;
String          run_name;
XWMHints        xwh;
XSizeHints      xsh;
Widget          toplevel, form, panel, funcbtn, menu, popref, popdialog, panelcolor,
                poplabel, entry;
Widget          popform, about;
GC              gc, gcs, gcm, gch, gcd, gcdb, gcdt, gcval, gcw;
Display         *disp;
Window          win;
Pixmap          pixmap, pixmapb, icon;
Pixmap          pixd0, pixd1, pixd2, pixd3, pixd4, pixd5, pixd6, pixd7, pixd8,
                pixd9, pixdc;
XSetWindowAttributes attri;
unsigned long   mask;
Colormap        cmap;
Font            dateFont;
int             poped = 0, panelmode = ANALOG, panelmodeTMP,
                dateflag = 1, weekflag = 1, displockflag = 0;
Cursor          cursorhand;

char            *monthname[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Juy",
				 "Aug", "Sep", "Oct", "Nov", "Dec"};
char            *weekname[] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
int             weekval[] = {165, 140, 120, 90, 60, 36, 15};
char            disptime1[] = "                ";
char            disptime2[] = "                ";
XtIntervalId    backlight_timer_ID;
int             optionflag = 0;
String          optionarg[10];
String          optionval[10];
int             digcolor = 0;

static XrmOptionDescRec options[] = {
    {"-geometry", ".geometry", XrmoptionSepArg, NULL}
};

enum colorname { Black, Gray40, Gray50 , Gray70, Gray90, White, Purple, Turquoise3, Cyan, LimeGreen,
		   Yellow, YellowGreen, Orange, HotPink, Red, Brown, MediumPurple, Turquoise, Forestgreen
	       };

String          color_name[] = {"Black", "Grey40", "Grey50", "Gray70", "Gray90", "White",
    "Purple", "Turquoise3", "Cyan", "LimeGreen", "YellowGreen",
    "Yellow", "Orange", "HotPink", "Red", "Brown",
    "MediumPurple", "Turquoise", "Forestgreen"
};
XColor          xc[ XtNumber(color_name)], exact, xcval[1], xcpanel[1];
 
String          item_names[] = { "Analog/Digital", "Reference", "Quit"};

typedef struct {
    char           *attrmask;
    char           *attrxpm;
    int             attrwidth;
    int             attrheight;
}               Attrdata;

Attrdata        topdata = {mdclock_bits, (char *) mdclock2, panel_width, panel_height};
Attrdata        topdataB = {mdclockB_bits, (char *) mdclock2, panel_width, panel_height};
Attrdata        paneldata = {panel_bits, (char *) mdclock2, panel_width, panel_height};
Attrdata        paneldata1 = {panel_bits, (char *) mdclock3, panel_width, panel_height};

void
AboutPopdown_proc()
{
     XtPopdown(about);
}

void
AboutPopup_proc()
{
     XtPopup(about, XtGrabNone);
}

String          fallback_resources[] = {
    "*form*poplabel.translations: #override \\n\
    <EnterWindow>:                  AboutPopup_proc() \\n\
    <LeaveWindow>:                  AboutPopdown_proc()",
    "*about.geometry:               600x20+200+0",
    "*about*background:             lightblue",
    "*about*foreground:             blue",
    "*panel.translations: #override \\n\
    <EnterWindow>:                  BacklightOn_proc() \\n\
    <LeaveWindow>:                  BacklightOff_proc() \\n\
    <Expose>:                       DisplayPanel_proc() \\n\
    <MapNotify>:                    DisplayPanel_proc()",
    "*funcbtn.translations: #override \\n\
    <EnterWindow>:                  FunclightOn_proc() \\n\
    <LeaveWindow>:                  FunclightOff_proc()",
    "*funcbtn.shapeStyle:           oval",
    "*form.funcbtn.background:      forestgreen",
    "*form.menu.background:         forestgreen",
    "*form.menu*foreground:         green",
    "*form.menu.Quit.foreground:    red",
    "*popref.popform.background:    ivory3",
    "*OK.shapeStyle:                oval",
    "*OK.background:                pink",
    "*poplabel.foreground:          blue",
    "*poplabel.background:          lightblue",
    "*poplabel.height:              20",
    "*poplabel.label:               WIVER Zealtium IIa",
    "*Scrollbar.orientation:        horizontal",
    "*bar.height:                   10",
    "*Scrollbar.topOfThumb:         0.5",
    "*form.menu.Reference.rightMargin:  30",
    "*form.menu.Reference.rightBitmap:    /usr/X11R6/include/X11/bitmaps/menu16",
    NULL,
};

void
BacklightOn_proc(Widget wd)
{
    time_t          now;
    struct tm       *tmstruct;

    if (panelmode != BACKON) {
	panelmodeTMP = panelmode;
	panelmode = BACKON;
    }
    if (panelmode == BACKON) {
	time(&now);
	tmstruct = localtime(&now);
	XSetForeground(disp, gc, xcpanel[0].pixel);
	XFillArc(disp, XtWindow(wd), gc, 14, 14, panel_width - 30, panel_height - 30, 360 * 64, 360 * 64);
	sprintf(&disptime1[0], "%s %s %02d\n", weekname[tmstruct->tm_wday],
		monthname[tmstruct->tm_mon], tmstruct->tm_mday);
	sprintf(&disptime2[0], " %02d:%02d:%02d\n", tmstruct->tm_hour, tmstruct->tm_min, tmstruct->tm_sec);
	XSetForeground(disp, gc, xc[Black].pixel);
	XDrawString(disp, XtWindow(wd), gc, 20, 45, disptime1, 10);
	XDrawString(disp, XtWindow(wd), gc, 20, 65, disptime2, 9);
	XSelectInput(disp, XtWindow(panel), ExposureMask | LeaveWindowMask);
	backlight_timer_ID = XtAppAddTimeOut(app_con, INTERVAL_TIME,
		    (XtTimerCallbackProc) BacklightOn_proc, (XtPointer) wd);
    }
}

void  DisplayPanel_proc();
void
BacklightDelayOff_proc()
{
    XtRemoveTimeOut(backlight_timer_ID);
    DisplayPanel_proc();
    panelmode = panelmodeTMP;
    XSelectInput(disp, XtWindow(panel), ExposureMask | EnterWindowMask | LeaveWindowMask);
}

void
BacklightOff_proc(Widget wd)
{
    XtAppAddTimeOut(app_con, LIGHTOFF_TIME, (XtTimerCallbackProc) BacklightDelayOff_proc, NULL);
}

void
FunclightOn_proc(Widget wd)
{
    XSetForeground(disp, gc, xc[Red].pixel);
    XFillArc(disp, XtWindow(wd), gc, 0, 0, funcbtn_width, funcbtn_height, 360 * 64, 360 * 64);
}

void
FunclightOff_proc(Widget wd)
{
    XClearWindow(disp, XtWindow(wd));
}

void
Popdown_proc()
{
    xcpanel[0].pixel = xcval[0].pixel;
    XtPopdown(popref);
    poped = 0;
    displockflag = 0;
}

void
DisplayPanel_proc()
{
    double          cho, tan, jikan, byo, obyo, week;
    int             x, y, deg, pixcnt, pixpos, pixposy;
    char            timedata[] = "  ";
    time_t          now;
    struct tm       *tmstruct;

    if (displockflag == 1) {
      return;
    }

    XSetForeground(disp, gc, xc[Black].pixel);
    time(&now);
    tmstruct = localtime(&now);

    cho = tmstruct->tm_min - 15;
    if (cho < 0)
	cho = cho + 60;
    cho = cho * 6.0;
    if (tmstruct->tm_hour >= 12)
	jikan = (tmstruct->tm_hour - 12);
    else
	jikan = tmstruct->tm_hour;
    tan = jikan * 30 + (tmstruct->tm_min * 0.5);
    tan = tan - 90;
    if (tan < 0)
	tan = tan + 360;

    byo = tmstruct->tm_sec - 15;
    if (byo < 0)
	byo = byo + 60;
    byo = byo * 6;
    deg = 360 - byo;

    switch (panelmode) {
    case NORMAL:
	break;
    case ANALOG:
	if (obyo != byo) {
	    XClearWindow(disp, XtWindow(panel));

	    if (dateflag == 1) {
	      if (tmstruct->tm_mday < 10) {
		sprintf(&timedata[0], " %d", tmstruct->tm_mday);
	      } else {
		sprintf(&timedata[0], "%02d", tmstruct->tm_mday);
	      }
	      XFillRectangle(disp, XtWindow(panel), gcdb, 68, 53, 12, 10);
	      XDrawString(disp, XtWindow(panel), gcdt, 70, 61, timedata, 2);
	    }

	    x = 50 + cos(byo * RAD) * 13;
	    y = 66 + sin(byo * RAD) * 13;
	    XDrawLine(disp, XtWindow(panel), gcs, 50, 67, x, y);
	    XFillArc(disp, XtWindow(panel), gcs, 49, 66, 3, 3, 360 * 64, 360 * 64);

	    tan = 360 - tan;
	    XFillArc(disp, XtWindow(panel), gch, 25 + 25 * cos(tan * RAD), 25 - 25 * sin(tan * RAD),
		     50, 50, (tan - 188) * 64, 18 * 64);

	    cho = 360 - cho;
	    XFillArc(disp, XtWindow(panel), gcm, 12 + 38 * cos(cho * RAD), 12 - 38 * sin(cho * RAD),
		     76, 76, (cho - 184) * 64, 8 * 64);

	    if (weekflag == 1) {
	      week = weekval[tmstruct->tm_wday];
	      XFillArc(disp, XtWindow(panel), gcw, 20 + 30 * cos(week * RAD),
		       20 - 30 * sin(week * RAD), 60, 60, (week - 184) * 64, 2 * 64);
	    }
	      
	    XFillArc(disp, XtWindow(panel), gcd, 47, 47, 6, 6, 360 * 64, 360 * 64);
	    XDrawArc(disp, XtWindow(panel), gcdt, 46, 46, 7, 7, 360 * 64, 360 * 64);
	    obyo = byo;
	}
	break;
    case DIGITAL:
	sprintf(&disptime1[0], "%s %s %02d\n", weekname[tmstruct->tm_wday],
		monthname[tmstruct->tm_mon], tmstruct->tm_mday);
	sprintf(&disptime2[0], " %02d:%02d:%02d\n", tmstruct->tm_hour, tmstruct->tm_min, tmstruct->tm_sec);
	pixpos = 15;
	pixposy = 38;
	XSetForeground(disp, gc, xc[Black].pixel);
	XFillArc(disp, XtWindow(panel), gc, 14, 14, 70, 70, 360 * 64, 360 * 64);
	if (obyo != byo) {
	    for (pixcnt = 0; pixcnt < 5; pixcnt++) {
		switch (disptime2[pixcnt + 1]) {
		case '0':
		    XCopyArea(disp, pixd0, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '1':
		    XCopyArea(disp, pixd1, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '2':
		    XCopyArea(disp, pixd2, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '3':
		    XCopyArea(disp, pixd3, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '4':
		    XCopyArea(disp, pixd4, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '5':
		    XCopyArea(disp, pixd5, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '6':
		    XCopyArea(disp, pixd6, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '7':
		    XCopyArea(disp, pixd7, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '8':
		    XCopyArea(disp, pixd8, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '9':
		    XCopyArea(disp, pixd9, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case ':':
		    pixpos -= 0;
		    XCopyArea(disp, pixdc, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    pixpos -= 8;
		    break;
		}
	    }
	    pixpos = 35;
	    pixposy = 58;
	    for (pixcnt = 0; pixcnt < 2; pixcnt++) {
		switch (disptime2[pixcnt + 7]) {
		case '0':
		    XCopyArea(disp, pixd0, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '1':
		    XCopyArea(disp, pixd1, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '2':
		    XCopyArea(disp, pixd2, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '3':
		    XCopyArea(disp, pixd3, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '4':
		    XCopyArea(disp, pixd4, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '5':
		    XCopyArea(disp, pixd5, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '6':
		    XCopyArea(disp, pixd6, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '7':
		    XCopyArea(disp, pixd7, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '8':
		    XCopyArea(disp, pixd8, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		case '9':
		    XCopyArea(disp, pixd9, XtWindow(panel), gc, 0, 0, 16, 21,
			      (pixpos + pixcnt * PIXPOSSTEP), pixposy);
		    break;
		}
	    }
	    obyo = byo;
	}
    }
}

void
Display_proc()
{
    DisplayPanel_proc();
    XtAppAddTimeOut(app_con, INTERVAL_TIME, (XtTimerCallbackProc) Display_proc, NULL);
}

void
Digred_proc()
{
    XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR0, &pixd0, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR1, &pixd1, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR2, &pixd2, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR3, &pixd3, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR4, &pixd4, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR5, &pixd5, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR6, &pixd6, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR7, &pixd7, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR8, &pixd8, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR9, &pixd9, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), FDRC, &pixdc, 0, 0);
    panelmode = DIGITAL;
    DisplayPanel_proc();
};

void
Diggreen_proc()
{
    XCreatePixmapFromData(disp, RootWindow(disp, 0), D0, &pixd0, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), D1, &pixd1, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), D2, &pixd2, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), D3, &pixd3, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), D4, &pixd4, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), D5, &pixd5, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), D6, &pixd6, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), D7, &pixd7, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), D8, &pixd8, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), D9, &pixd9, 0, 0);
    XCreatePixmapFromData(disp, RootWindow(disp, 0), Dc, &pixdc, 0, 0);
    panelmode = DIGITAL;
    DisplayPanel_proc();
};

void
Analog_proc()
{
    panelmode = ANALOG;
    DisplayPanel_proc();
}

static XtActionsRec actions[] = {
    {"FunclightOn_proc", (XtActionProc) FunclightOn_proc},
    {"FunclightOff_proc", (XtActionProc) FunclightOff_proc},
    {"BacklightOn_proc", (XtActionProc) BacklightOn_proc},
    {"BacklightOff_proc", (XtActionProc) BacklightOff_proc},
    {"Popdown_proc", (XtActionProc) Popdown_proc},
    {"Display_proc", (XtActionProc) Display_proc},
    {"DisplayPanel_proc", (XtActionProc) DisplayPanel_proc},
    {"Analog_proc", (XtActionProc) Analog_proc},
    {"Diggreen_proc", (XtActionProc) Diggreen_proc},
    {"Digred_proc", (XtActionProc) Digred_proc},
    {"AboutPopup_proc", (XtActionProc) AboutPopup_proc},
    {"AboutPopdown_proc", (XtActionProc) AboutPopdown_proc},
};

void
WtSetWindowAttributes(Display * disp, Widget wdp, Widget wd, Attrdata * ap, int flag)
{
    Window          winp, win;
    winp = XtWindow(wdp);
    win = XtWindow(wd);
    switch (flag) {
    case 0:
	break;
    case mskEnable:
	/* Shape set */
	pixmapb = XCreateBitmapFromData(disp, winp, ap->attrmask, ap->attrwidth, ap->attrheight);
	XShapeCombineMask(disp, winp, ShapeBounding, 0, 0, pixmapb, ShapeSet);
	break;
    case xpmEnable:
	/* xpm set */
	XCreatePixmapFromData(disp, win, (char **) ap->attrxpm, &pixmap, NULL, 0);
	attri.background_pixmap = pixmap;
	mask = CWBackPixmap;
	XChangeWindowAttributes(disp, win, mask, &attri);
	break;
    case xpmmskEnable:
	pixmapb = XCreateBitmapFromData(disp, winp, ap->attrmask, ap->attrwidth, ap->attrheight);
	XShapeCombineMask(disp, winp, ShapeBounding, 0, 0, pixmapb, ShapeSet);
	XCreatePixmapFromData(disp, win, (char **) ap->attrxpm, &pixmap, NULL, 0);
	attri.background_pixmap = pixmap;
	mask = CWBackPixmap;
	XChangeWindowAttributes(disp, win, mask, &attri);
	break;
    }
}

void
set_color_data(Display * disp)
{
    int             i, r;
    cmap = DefaultColormap(disp, 0);
    for (i = 0; i < XtNumber(color_name); i++) {
	r = XAllocNamedColor(disp, cmap, color_name[i], &xc[i], &exact);
	if (r == 0) {
	    fprintf(stderr, "%s: \"%s\" is unknown color for me.\n", run_name, color_name[i]);
	}
    }
}

void
jump_proc(Widget wd, XtPointer client_data, XtPointer  call_data)
{
  float percent = *((float *) call_data);
  displockflag = 1;
  xcval[0].pixel = (int)(percent * 65535);
  XSetForeground(disp, gcval, xcval[0].pixel);
  XSetWindowBorder(disp, XtWindow(wd), xcval[0].pixel);
  XFillArc(disp, XtWindow(panel), gcval, 14, 14,
	   panel_width - 30, panel_height - 30, 360 * 64, 360 * 64);
}

void
weekOnOff()
{
  if(weekflag == 1) {
    weekflag = 0;
    WtSetWindowAttributes(disp, panel, panel, &paneldata, xpmmskEnable);
  } else {
    weekflag = 1;
    WtSetWindowAttributes(disp, panel, panel, &paneldata1, xpmmskEnable);
  }
}

void
dateOnOff()
{
  if(dateflag == 1) {
    dateflag = 0;
  } else {
    dateflag = 1;
  }
}

void
MenuSelect(Widget w, int i)
{
    switch (i) {
	case 0:
	if (panelmode == ANALOG) {
	    panelmode = DIGITAL;
	    DisplayPanel_proc();
	    break;
	}
	if (panelmode == DIGITAL) {
	    panelmode = ANALOG;
	    DisplayPanel_proc();
	    break;
	}
	break;
    case 1:
	if (poped != POPED) {
	    poped = POPED;
	    popref = XtVaCreatePopupShell("popref", topLevelShellWidgetClass, form, NULL);
	    popform = XtVaCreateManagedWidget("popform", formWidgetClass, popref, NULL);

	    poplabel = XtVaCreateManagedWidget("poplabel", labelWidgetClass, popform,
			      XtNinternational, 1, XtNborderWidth, 0, NULL);
	    XtAddCallback(XtVaCreateManagedWidget("OK", commandWidgetClass, popform,
                                             XtNfromHoriz, poplabel, NULL),
			                     XtNcallback, (XtCallbackProc)Popdown_proc, NULL);

	    popdialog = XtVaCreateManagedWidget("popdialog", dialogWidgetClass, popform,
						XtNlabel, "DISPLAY", XtNfromVert, poplabel, NULL);
	    XawDialogAddButton(popdialog, "ANALOG", Analog_proc, NULL);
	    XawDialogAddButton(popdialog, "date", dateOnOff, NULL);
	    XawDialogAddButton(popdialog, "week", weekOnOff, NULL);
	    XawDialogAddButton(popdialog, "DIGITAL(G)", Diggreen_proc, NULL);
	    XawDialogAddButton(popdialog, "DIGITAL(R)", Digred_proc, NULL);

	    XtAddCallback(XtVaCreateManagedWidget("bar", scrollbarWidgetClass, popform, XtNwidth, 100,
						  XtNfromVert, popdialog, XtNborderWidth, 5, NULL),
			                          XtNjumpProc, jump_proc, NULL);

	    about = XtVaCreatePopupShell("about", simpleMenuWidgetClass, toplevel,
					 XtNlabel, rcsid, NULL);
	    XtPopup(popref, XtGrabNone);
	}
	break;
    case 2:
	XFreeGC(disp, gc);
	XFreeGC(disp, gcs);
	XFreeGC(disp, gcm);
	XFreeGC(disp, gch);
	XFreeGC(disp, gcd);
	XFreeGC(disp, gcdb);
	XFreeGC(disp, gcdt);
	XFreeGC(disp, gcval);
	XFreeGC(disp, gcw);
	XtDestroyApplicationContext(XtWidgetToApplicationContext(toplevel));
	exit(0);
	break;
    }
}

void
FixWindowSizeIcon(Display * disp, Window win)
{
    XCreatePixmapFromData(disp, win, mdclockicon, &icon, 0, 0);
    xwh.flags = IconPixmapHint;
    xwh.icon_pixmap = icon;

    xwh.flags = IconPixmapHint;
    XSetWMHints(disp, win, &xwh);
    xsh.flags = (PMinSize | PMaxSize);
    xsh.flags = (USPosition | PMinSize | PMaxSize);
    xsh.max_width = MAXWW;
    xsh.max_height = MAXWH;
    xsh.min_width = MINWW;
    xsh.min_height = MINWH;
    XSetWMNormalHints(disp, win, &xsh);
}


void
initialize()
{
    disp = XtDisplay(toplevel);
    set_color_data(disp);
    gc = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
    gcs = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
    gcm = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
    gch = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
    gcd = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
    gcdb = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
    gcdt = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
    gcval = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
    gcw = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
    XSetForeground(disp, gcs, xc[Yellow].pixel);
    XSetForeground(disp, gcm, xc[LimeGreen].pixel);
    XSetForeground(disp, gch, xc[Red].pixel);
    XSetForeground(disp, gcd, xc[Gray70].pixel);
    XSetForeground(disp, gcdb, xc[Gray70].pixel);
    XSetForeground(disp, gcdt, xc[Black].pixel);
    XSetForeground(disp, gcw, xc[Turquoise3].pixel);
    XSetLineAttributes(disp, gcs, 1, LineSolid, CapRound, JoinMiter);
    XSetLineAttributes(disp, gch, 1, LineSolid, CapRound, JoinMiter);
    XSetLineAttributes(disp, gcm, 1, LineSolid, CapRound, JoinMiter);
    dateFont = XLoadFont(disp, "-*-*-*-*-*-*-*-*-*-*-*50-*-*");
    XSetFont(disp, gcdt, dateFont);
    xcpanel[0].pixel = xc[Turquoise].pixel;
    xcval[0].pixel = xc[Turquoise].pixel;
    cursorhand = XCreateFontCursor(disp, XC_hand2);

    /*
     * locale $B$r@_Dj$9$k$H5/F0$K;~4V$,3]$+$k!#(B XtSetLanguageProc(NULL,
     * NULL, NULL); setlocale(LC_CTYPE, "");
     */
    if (digcolor == 0) {
	XCreatePixmapFromData(disp, RootWindow(disp, 0), D0, &pixd0, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), D1, &pixd1, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), D2, &pixd2, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), D3, &pixd3, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), D4, &pixd4, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), D5, &pixd5, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), D6, &pixd6, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), D7, &pixd7, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), D8, &pixd8, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), D9, &pixd9, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), Dc, &pixdc, 0, 0);
    }
    if (digcolor == 1) {
	XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR0, &pixd0, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR1, &pixd1, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR2, &pixd2, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR3, &pixd3, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR4, &pixd4, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR5, &pixd5, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR6, &pixd6, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR7, &pixd7, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR8, &pixd8, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), FDR9, &pixd9, 0, 0);
	XCreatePixmapFromData(disp, RootWindow(disp, 0), FDRC, &pixdc, 0, 0);
    }
}

void
programend()
{
    printf("\nUsage : mdclock\n");
    printf(" [-digitcolor red/green][-geometry {+-}xoffset{+-}yoffset]\n [-display hostname:dpy.scr]\n\n");
    exit(0);
}

void
get_option(int argc, char *argv[])
{
#define DIGIT "-digitcolor"
#define DIGITGREEN "green"
#define DIGITRED "red"
#define HOST  "-host"

    int             i;
    /*
     * optionflag       $B%*%W%7%g%s?t(B
     * optionarg[i]     $B%*%W%7%g%s;XDjL>(B
     * optionval[i]     $B%*%W%7%g%sCM(B
     */

    for (i = 1; i < argc; i++) {
      optionarg[i] = " ";
      optionval[i] = " ";
      if ((strcmp(argv[i], DIGIT) == 0) || (strcmp(argv[i], HOST) == 0)) {
	optionarg[i] = argv[i];
	optionval[i] = argv[i + 1];
	optionflag++;
	i++;
      }
    }

    for (i = 1; i < argc; i++) {
	if ((strcmp(optionarg[i], DIGIT) == 0)) {
	    if ((strcmp(optionval[i], DIGITGREEN)) == 0) {
		digcolor = 0;
	    }
	    if ((strcmp(optionval[i], DIGITRED)) == 0) {
		digcolor = 1;
	    }
	}
	i++;
    }
}

void
main(int argc, char *argv[])
{
    int             i;
    run_name = argv[0];

    get_option(argc, &argv[0]);

    toplevel = XtVaAppInitialize(&app_con, "WIVER",
	 options, XtNumber(options), &argc, argv, fallback_resources, NULL);

    initialize();

    form = XtVaCreateManagedWidget("form", formWidgetClass, toplevel,
	  XtNwidth, topdata.attrwidth, XtNheight, topdata.attrheight, NULL);
    panel = XtVaCreateManagedWidget("panel", formWidgetClass, form,
		 XtNwidth, topdata.attrwidth, XtNheight, topdata.attrheight,
	  XtNborderWidth, 0, XtNhorizDistance, 0, XtNvertDistance, 0, NULL);
    funcbtn = XtVaCreateManagedWidget("funcbtn", menuButtonWidgetClass, form,
			   XtNhorizDistance, 85, XtNvertDistance, 85, NULL);
    XtVaSetValues(funcbtn, XtNlabel, " ", XtNwidth, funcbtn_width, XtNheight, funcbtn_height, NULL);
    menu = XtVaCreatePopupShell("menu", simpleMenuWidgetClass, form, NULL);

    for (i = 0; i < (int) XtNumber(item_names); i++) {
	entry = XtVaCreateManagedWidget(item_names[i], smeBSBObjectClass,
				       menu, XtNlabel, item_names[i], NULL);
	XtAddCallback(entry, XtNcallback, (XtCallbackProc) MenuSelect, (XtPointer) i);
    }

    XtAppAddActions(app_con, actions, XtNumber(actions));
    XtAppAddTimeOut(app_con, INTERVAL_TIME, (XtTimerCallbackProc) Display_proc, (XtPointer) toplevel);
    XtRealizeWidget(toplevel);
    XSelectInput(disp, XtWindow(panel), ExposureMask | EnterWindowMask | LeaveWindowMask);

    WtSetWindowAttributes(disp, toplevel, form, &topdata, mskEnable);
    WtSetWindowAttributes(disp, form, form, &topdata, xpmmskEnable);
    WtSetWindowAttributes(disp, panel, panel, &paneldata1, xpmmskEnable);
    XDefineCursor(disp, XtWindow(funcbtn), cursorhand);

    FixWindowSizeIcon(disp, XtWindow(toplevel));
    XtAppMainLoop(app_con);
}
